<?php
/**
 * block.t.php - Smarty gettext block plugin
 *
 * ------------------------------------------------------------------------- *
 * This library is free software; you can redistribute it and/or             *
 * modify it under the terms of the GNU Lesser General Public                *
 * License as published by the Free Software Foundation; either              *
 * version 2.1 of the License, or (at your option) any later version.        *
 *                                                                           *
 * This library is distributed in the hope that it will be useful,           *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Lesser General Public License for more details.                           *
 *                                                                           *
 * You should have received a copy of the GNU Lesser General Public          *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * ------------------------------------------------------------------------- *
 *
 * Installation: simply copy this file to the smarty plugins directory.
 *
 * @package	smarty-gettext
 * @version	$Id: block.t.php,v 2.1
 * @author	Marcin Filipiak <mfilipiak@bmf.com.pl>
 * @copyright   2010 Marcin Filipiak
 */
 
/**
 * Replaces arguments in a string with their values.
 * Arguments are represented by % followed by their number.
 *
 * @param	string	Source string
 * @param	mixed	Arguments, can be passed in an array or through single variables.
 * @returns	string	Modified string
 */

	$db=mysql_connect(DB_HOST,DB_USERNAME,DB_PASSWORD);
	mysql_select_db(DB_NAME,$db);

function smarty_gettext_strarg($str)
{
	$tr = array();
	$p = 0;

	for ($i=1; $i < func_num_args(); $i++) {
		$arg = func_get_arg($i);
		
		if (is_array($arg)) {
			foreach ($arg as $aarg) {
				$tr['%'.++$p] = $aarg;
			}
		} else {
			$tr['%'.++$p] = $arg;
		}
	}
	
	return strtr($str, $tr);
}

/**
 * Tlumaczy $text na podstawie pliku translate.po 
 * do ktorego sciezka podana jest w $path
 */
function translate_from_po($textin, $path){
	
	$found = false; //czy znaleziono 
	$translated = false;//czy przetlumaczono
	
	$fh = fopen($path, 'r') or die("can't open config file $path");
	
	while(!feof($fh)){
				$textfile = fgets($fh);
				if ($found){
					$textout = $textfile;
					//$textout = str_replace("msgstr \"", "", $textout);
					$textout = substr($textout, 8, strlen($textout)-10);
					$translated = true;
				}
				if (eregi("msgid \"$textin\"","$textfile")){
					$textout = $textfile;
					$found = true;
					}
				else{
					$found = false;
					}
	}
    fclose($fh);
	//nie znaleziono tlumaczenia lub jeszcze nie wpisano tłumaczenia dla tego tekstu
	if (!$translated || $textout==""){
		$textout = $textin;
	}
	return $textout;
}

/***
 * Tlumaczy $textin z bazy danych
 ***/
function translate_from_db($textin, $language){

    		//usuwanie enterow z sentencji
		//$textin = stripslashes($textin);
                
	//szukanie tlumaczenia dla tekstu w danym jezyku
	$sql="SELECT translation FROM translations WHERE language_code = '$language' AND oryginal = '$textin' ";
	$result=mysql_query($sql);
	$row = mysql_fetch_assoc($result);

	//jesli znaleziono tlumaczenie
	if (!empty($row['translation'])){
		$trans = $row['translation'];
	}
	//jesli nie znaleziono tlumaczenia wyswietlenie w oryginale
	else {
		$trans = $textin;

                //sprawdzenie czy jest juz dodany do bazy
                $do = mysql_query("SELECT * FROM translations WHERE oryginal='$textin' AND language_code = '$language'");
                $num = mysql_num_rows($do);
                //jesli nie ma
                if( $num == 0 ){
                        // dopisanie 
                        mysql_query("INSERT INTO translations (oryginal,language_code) VALUES ('$textin','$language')");
                }
	}
	
	//zwrot przetlumaczonego tekstu
	return $trans;
	
}

/**
 * Pobiera wybrany jezyk
 * z ciasteczka
 **/
function get_language(){
		//pobranie jezyka z ciasteczka
                $lng = $_COOKIE['lng'];
		//jesli okreslono jezyk
		if ($lng!=""){
                    return $lng;
		}
		//jesli brak okreslonego jezyka
		else {
                    return "";
                }
}


/**
 * Smarty block function, provides gettext support for smarty.
 * The block content is the text that should be translated.
 */
function smarty_block_t($params, $text, &$smarty){
	//$text = stripslashes($text);
	//jesli wybrany jest jezyk obcy i trzeba tlumaczyc
	
	$selected_language = get_language();
	
	if ($selected_language != ""){

            /*
            //tlumaczenie na podstawie plikow po
            $text = translate_from_po($text,getcwd()."/locale/".$selected_language."/LC_MESSAGES/translation.po");
            */

            //tlumaczenie na podstawie bazy danych
            $text = translate_from_db($text,$selected_language);
	}			
	return $text;
}

?>